diff --git a/sha256_transform.v b/sha256_transform.v
index b59779a..33ab034 100644
--- a/sha256_transform.v
+++ b/sha256_transform.v
@@ -329,15 +329,17 @@ generate
 `ifdef USE_XILINX_BRAM_FOR_W
 	if(LENGTH >= 8) begin
 		reg [7:0] addr = 0;
-		reg [31:0] r; 
-		reg [31:0] m[0:(LENGTH-2)];
+		(* KEEP = "TRUE" *) reg [31:0] r;
+		reg [31:0] r2;
+		reg [31:0] m[0:(LENGTH-3)];
 		always @ (posedge clk)
 		begin
-			addr <= (addr + 1) % (LENGTH - 1);
+			addr <= (addr + 1) % (LENGTH - 2);
 			r <= m[addr];
+			r2 <= r;
 			m[addr] <= val_in;
 		end
-		assign val_out = r;
+		assign val_out = r2;
 	end else begin
 `endif
 		reg [32 * LENGTH - 1:0] r;
